from channels.auth import AuthMiddlewareStack
from channels.routing import ChannelNameRouter, ProtocolTypeRouter, URLRouter
from channels.security.websocket import AllowedHostsOriginValidator

from arkindex.documents.consumers import CorpusConsumer, MLResultsConsumer, ReindexConsumer
from arkindex.project.triggers import CORPUS_CHANNEL, ML_RESULTS_CHANNEL, REINDEX_CHANNEL

application = ProtocolTypeRouter({
    'websocket': AllowedHostsOriginValidator(
        AuthMiddlewareStack(
            URLRouter([
            ]),
        ),
    ),
    'channel': ChannelNameRouter({
        REINDEX_CHANNEL: ReindexConsumer,
        ML_RESULTS_CHANNEL: MLResultsConsumer,
        CORPUS_CHANNEL: CorpusConsumer,
    })
})
